<template>
  <unauth-layout>
    <template #title>
      {{ title }}
    </template>
    <form v-if="step === 'email'" @submit.prevent="submitEmail">
      <div class="form-field">
        <label for="email">Почта</label>
        <input-text
          id="email"
          v-model="email"
          label="Почта"
          type="text"
          autocomplete="email"
          :disabled="loading"
        />
      </div>
      <div>
        <prime-button type="submit">
          Подтвердить
        </prime-button>
      </div>
    </form>
    <div v-else-if="step === 'code'">
      <form @submit.prevent="submitCode">
        <div class="form-field">
          <label for="code">Код</label>
          <input-text
            id="code"
            v-model="code"
            label="Код"
            type="text"
            autocomplete="none"
            :disabled="loading"
          />
        </div>
        <div>
          <prime-button type="submit">
            Подтвердить
          </prime-button>
        </div>
      </form>
    </div>
    <div v-else>
      <form @submit.prevent="submitPassword">
        <div class="form-field">
          <label for="password">Пароль</label>
          <input-text
            id="password"
            v-model="password"
            label="Пароль"
            type="password"
            autocomplete="current-password"
            :disabled="loading"
          />
        </div>
        <div>
          <prime-button type="submit">
            Подтвердить
          </prime-button>
        </div>
      </form>
    </div>
  </unauth-layout>
</template>
<script lang="ts">
import PrimeButton from 'primevue/button/Button.vue';
import InputText from 'primevue/inputtext/InputText.vue';
import { defineComponent } from 'vue';
import { forgotPassword, resetPassword } from '@/api/handler/login';
import UnauthLayout from '@/layout/UnauthLayout.vue';

type ResetPasswordForm = 'email' | 'code' | 'password';

interface Data {
  email: string;
  code: string;
  password: string;
  loading: boolean,
  step: ResetPasswordForm;
}
export default defineComponent({
  name: 'reset-password',
  components: {
    PrimeButton,
    InputText,
    UnauthLayout,
  },
  data(): Data {
    return {
      email: '',
      code: '',
      password: '',
      loading: false,
      step: 'email',
    };
  },
  computed: {
    emailFromQuery(): string | null {
      if (typeof(this.$route.query.email) === 'string') {
        return this.$route.query.email;
      }

      return null;
    },
    codeFromQuery(): string | null {
      if (typeof(this.$route.query.code) === 'string') {
        return this.$route.query.code;
      }

      return null;
    },
    title() {
      if (this.step === 'code') {
        return 'Введите код, который пришел вам на почту';
      } else if (this.step === 'password') {
        return 'Введите новый пароль';
      }
      return 'Восстановить пароль';
    },
  },
  created() {
    if (this.emailFromQuery) {
      this.step = 'code';
      this.email = this.emailFromQuery;
    }
    if (this.codeFromQuery) {
      this.step = 'password';
      this.code = this.codeFromQuery;
    }
  },
  methods: {
    async submitEmail() {
      this.loading = true;
      const res = await forgotPassword({ email: this.email });
      if (res.__state === 'success') {
        this.step = 'code';
      }
      this.loading = false;
    },
    submitCode() {
      if (this.code.length !== 6) {
        return;
      }
      this.step = 'password';
    },
    async submitPassword() {
      this.loading = true;
      const res = await resetPassword({
        code: Number(this.code),
        email: this.email,
        password: this.password,
      });
      if (res.__state === 'success') {
        this.$router.push({ name: 'login' });
      }
    },
  },
});
</script>
